// ---------------------------------------------------------------------

#include "image_functions.inc"





/***************************************
*
* Φ theta V M r Vܤpattern
*
*  radial_spread_mask_f_array vTA
* outputO@sb time(age) VWL noise function theta զX
*
* 
* f_output(time, theta)
*
*
****************************************/

#macro generate_thin_pattern_f_by_theta_chop(
f_noise_apply_vs_t, theta_blend_mode,
t_radial_bump_size, theta_pos_array,
radial_spread_mask_f_array, // radial_spread_mask_f_array ƶqnM theta_pos_array @
radial_mask_f_mode, // mode = 0 ۭ, mode = 1 ĥ min
seed_m, theta_more_thin
)
    
    
    // theta blend mode
    #switch(theta_blend_mode)
        #case(0) // linear blend
            #local f_blend_rise_mod =
            f_linear_blend_rise;
        #break;
        #case(1) // cos - sin blend
            #local f_blend_rise_mod =
            f_cos_blend_rise;
        #break;
        #case(2) //
            #local par0 = 2.20;
            #local par1 = 2*pi;
            #local val0 = -4.1415;
            #local val1 = 5;
            #local par_l = par1 - par0;
        
            #local f_blend_rise_mod =
            function(th, th0, th1) {
            (
                  3* cos( par_l*(th - th0)/(th1 - th0) + par0)
                + 2* cos(2*( par_l*(th - th0)/(th1 - th0) + par0))
                -    cos(3*( par_l*(th - th0)/(th1 - th0) + par0))
                +    cos(4*( par_l*(th - th0)/(th1 - th0) + par0))
                - val0
            )/(val1 - val0)
            }
        
        #break
        #case(3)
        
        
        #break
    #end

    #local f_blend_fall_mod =
    function(th, th0, th1) {
    1 - f_blend_rise_mod(th, th0, th1)
    }
    
    

    
    
    // theta part array but time(radial) input function
    
    #local theta_node_amount = dimension_size(theta_pos_array, 1);
    
    
    #local f_thin_pattern_t_radial_detail = array[theta_node_amount];
    
    
    #if(theta_more_thin)
    // ----- theta pattern Fΰ}CA]bump  -----
        #local avg_theta_interval = 2*pi/theta_node_amount;
        #local more_thin_factor = 2.0; // }CCӤd򦳴Xbumps ܤơAӭnJ
        
        
        
        #for(i, 0, theta_node_amount - 1)
            #local a = rand(seed_m);
            #local b = 0.8 + 0.4*rand(seed_m);
            #local c = rand(seed_m);
            #if(i = 0)
                #local f_thin_pattern_body =
                function(var_t, theta) {
                select(
                    theta - pi, // ݬObWb٬OUb
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a),
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), (theta - 2*pi)*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                )
                }
                
            #elseif(i = theta_node_amount - 1)
                #local f_thin_pattern_body =
                function(var_t, theta) {
                select(
                    theta - pi, // ݬObWb٬OUb
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), (theta + 2*pi)*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a),
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                )
                }
            #else
                #local f_thin_pattern_body =
                function(var_t, theta) {
                f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                }
            #end
            
            #switch(radial_mask_f_mode)
                #case(0)
                    #local f_thin_pattern_t_radial_detail[i] =
                    function(var_t, theta) {
                    f_thin_pattern_body(var_t, theta)
                    *radial_spread_mask_f_array[i](var_t)
                    // radial_spread_mask_f(var_time)
                    }
                #break;
                #case(1)
                    #local f_thin_pattern_t_radial_detail[i] =
                    function(var_t, theta) {
                    min(
                    f_thin_pattern_body(var_t, theta),
                    radial_spread_mask_f_array[i](var_t)
                    // radial_spread_mask_f(var_time)
                    )
                    }
                #break;
            #end
            
            #undef f_thin_pattern_body
        
        #end    
        
            
        #local output_f =
        function(time, theta) {
        select(
            theta - theta_pos_array[0],
            f_thin_pattern_t_radial_detail[theta_node_amount - 1](time, theta)*f_blend_fall_mod(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]) + f_thin_pattern_t_radial_detail[0](time, theta)*f_blend_rise_mod(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]),
            #for(i, 1, theta_node_amount - 1)
                select(
                    theta - theta_pos_array[i],
                    f_thin_pattern_t_radial_detail[i-1](time, theta)*f_blend_fall_mod(theta, theta_pos_array[i-1], theta_pos_array[i]) + f_thin_pattern_t_radial_detail[i](time, theta)*f_blend_rise_mod(theta, theta_pos_array[i-1], theta_pos_array[i]),
            #end
                    f_thin_pattern_t_radial_detail[theta_node_amount - 1](time, theta)*f_blend_fall_mod(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi) + f_thin_pattern_t_radial_detail[0](time, theta)*f_blend_rise_mod(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi)
            
            #for(i, 0, theta_node_amount - 1)
                )
            #end
        }
        
        
    #else
    // ----- theta pattern ΰ}C -----
        #for(i, 0, theta_node_amount - 1)
            #local a = rand(seed_m);
            #local b = 0.8 + 0.4*rand(seed_m);
            #local c = rand(seed_m);
            
            #switch(radial_mask_f_mode)
                #case(0)
                    #local f_thin_pattern_t_radial_detail[i] =
                    function(var_t) {
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), 0, 2.5*theta_node_amount*a)
                    *radial_spread_mask_f_array[i](var_t)
                    // radial_spread_mask_f(var_time)
                    }
                #break;
                #case(1)
                    #local f_thin_pattern_t_radial_detail[i] =
                    function(var_t) {
                    min(
                    f_noise_apply_vs_t(var_t/(t_radial_bump_size*b), 0, 2.5*theta_node_amount*a),
                    radial_spread_mask_f_array[i](var_t)
                    // radial_spread_mask_f(var_time)
                    )
                    }
                #break;
            #end
        
        #end    
    
    
    
    
        #local output_f =
        function(time, theta) {
        select(
            theta - theta_pos_array[0],
            f_thin_pattern_t_radial_detail[theta_node_amount - 1](time)*f_blend_fall_mod(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]) + f_thin_pattern_t_radial_detail[0](time)*f_blend_rise_mod(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]),
            #for(i, 1, theta_node_amount - 1)
                select(
                    theta - theta_pos_array[i],
                    f_thin_pattern_t_radial_detail[i-1](time)*f_blend_fall_mod(theta, theta_pos_array[i-1], theta_pos_array[i]) + f_thin_pattern_t_radial_detail[i](time)*f_blend_rise_mod(theta, theta_pos_array[i-1], theta_pos_array[i]),
            #end
                    f_thin_pattern_t_radial_detail[theta_node_amount - 1](time)*f_blend_fall_mod(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi) + f_thin_pattern_t_radial_detail[0](time)*f_blend_rise_mod(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi)
            
            #for(i, 0, theta_node_amount - 1)
                )
            #end
        }
    
    #end
    
    
    
    // ٬OiHH theta_mask_f AOF
    
            
        
        
    output_f


#end



/***************************************
*
* generate_thin_pattern_f_by_theta_chop() internalA
* btimeVOLAӬO@ mask function
*
* Φ theta V M r VM hVܤpattern
*
*
*
* 
* f_output(time, theta, h)
*
*
****************************************/

#macro generate_thin_composite_1_pattern_f_input_t_theta_h(
first_time, last_time, d_boundary_time0, d_boundary_time1, t_radial_bump_size, time_node_amount, // time_node_amount >= 0A NjơA |ͦ time_node_amount + 1Ө
bump_size_along_theta, theta_pos_random_factor, //bump_size_along_theta jסA ΨӨDf_set C@theta_node_amount ,  0 < theta_pos_random_factor < 1 (valid)
min_h, max_h, d_boundary_h0, d_boundary_h1,
seed_m,
r_vs_t, h_vs_r_ratio // provide addition info to macro , (r_vs_t * time) ~= r
)

    
    
    // f_Set
    #local thin_pattern_f_set = array[time_node_amount + 1];
    
    #local time_extent_pos = array[time_node_amount + 2];
    #local time_interval = (last_time - first_time)/(time_node_amount + 1);
    #for(i, 0, time_node_amount + 1)
        #local time_extent_pos[i] = first_time + i* time_interval;
    
    #end
    
    
    
    
    
    
    #for(i, 0, time_node_amount)
        
        
        
        
        // theta pos
        #local mid_time_pos = (time_extent_pos[i] + time_extent_pos[i+1])/2;
        #local effective_r = r_vs_t *mid_time_pos; // ΨӱQŦXbump_size_along_theta j׮ɡAthetanhnode
        
        #local theta_node_amount = int(2*pi*effective_r/bump_size_along_theta);       
        #local avg_theta_interval = 2*pi/theta_node_amount;
        #local overall_theta_offset = (avg_theta_interval/2) *(1 - theta_pos_random_factor - 0.0001)* (2*rand(seed_m) - 1);
        
        
        #local theta_pos_array = array[theta_node_amount];
        
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_a = rand(seed_m);
            #local theta_pos_array[j] = avg_theta_interval/2 + j* avg_theta_interval + theta_pos_random_factor*(2*rand_num_a - 1)* avg_theta_interval/2 + overall_theta_offset;
        #end
        
        
        #local theta_blend_mode = 1; // cos - sin blend
        
        
        
        
        // radial( infact + theta for more thin theta) bump function
        #local f_noise_apply_vs_t_impl =
        function(var_t, var_theta,var_random) {
        f_noise3d(var_t, var_theta, var_random)
        }
                
        
                
        
        // radial mask function
        #local radial_mask_f_mode = 0;  // 0 multiple, 1 min
        
        #local radial_spread_mask_f_array = array[theta_node_amount];
        #for(j, 0, theta_node_amount - 1)
            #local rand_num_b = 2*rand(seed_m) - 1;
            #local rand_num_c = 2*rand(seed_m) - 1;
            #local fix_d_boundary_t0 = d_boundary_time0*(1 + 0.11*rand_num_b); // oӧ쪺0.11 M 0.16ᦳΨ
            #local fix_d_boundary_t1 = d_boundary_time1*(1 + 0.16*rand_num_c);
            
            
            #local radial_spread_mask_f_array[j] =
            function(var_t) {
            select(
                var_t - (time_extent_pos[i] - fix_d_boundary_t0/2),
                0,
                select(
                    var_t - (time_extent_pos[i] + fix_d_boundary_t0/2),
                    f_cos_blend_rise(var_t, time_extent_pos[i] - fix_d_boundary_t0/2 , time_extent_pos[i] + fix_d_boundary_t0/2),
                    select(
                        var_t - (time_extent_pos[i+1] - fix_d_boundary_t1/2),
                        1,
                        select(
                            var_t - (time_extent_pos[i+1] + fix_d_boundary_t1/2),
                            f_cos_blend_fall(var_t, time_extent_pos[i+1] - fix_d_boundary_t1/2, time_extent_pos[i+1] + fix_d_boundary_t1/2),
                            0
                        )
                        
                    )
                
                )
            )
            }
        #end
        
        
        
        
        // h bump function
        #local h_direct_bump_size = 0.1;
        
        #local f_noise_apply_vs_h_impl =
        function(h, var_random) {
        1 - pow(f_bumps(h/h_direct_bump_size, var_random, 100), 1.3)
        }
        
        
        
        // h mask function
        #local h_mask_f_mode = 1; // 0 multiple, 1 min
        
        
        
        #local h_mask_f =
        function(h) {
        select(
            h - min_h,
            0,
            select(
                h - (min_h + d_boundary_h0),
                f_parbl_step_rise(h, min_h, min_h + d_boundary_h0),
                select(
                    h - (max_h - d_boundary_h1),
                    1,
                    select(
                        h - max_h,
                        f_parbl_step_fall(h, max_h - d_boundary_h1, max_h),
                        0
                    )
                    
                )
            
            )
        )
        }
        
        
        
        
        #local seed_m1 = seed(rand(seed_m)*100);
        #local theta_more_thin = no;
        
        
        
        
        #local pattern_vs_t_theta = generate_thin_pattern_f_by_theta_chop(
        f_noise_apply_vs_t_impl, theta_blend_mode,
        t_radial_bump_size, theta_pos_array,
        radial_spread_mask_f_array,
        radial_mask_f_mode,
        seed_m1, theta_more_thin
        );
        
        
        #local rand_num_h = rand(seed_m)*50;
        
        
        #local thin_pattern_f_set[i] =
        function(var_t, theta, h) {
        #switch(h_mask_f_mode)
            #case(0)
                f_imitate_min_r1_5(
                pattern_vs_t_theta(var_t, theta),
                f_noise_apply_vs_h_impl(h, rand_num_h)
                )
                *h_mask_f(h)
            #break;
            #case(1)
                f_imitate_min_r1_5(
                    f_imitate_min_r1_5(
                    pattern_vs_t_theta(var_t, theta),
                    f_noise_apply_vs_h_impl(h, rand_num_h)
                    ),
                    h_mask_f(h)
                )
            #break;
        #end
        }
        
        
        #undef f_noise_apply_vs_t_impl
        #undef f_noise_apply_vs_h_impl
        #undef h_mask_f
        #undef radial_spread_mask_f_array
        #undef pattern_vs_t_theta
        
    #end
    
    
    
    #local t_extent_max = max(d_boundary_time0*1.16, d_boundary_time1*1.16);
    
    
    
    #local output_f = 
    function(var_t, theta, h) {
    select(
        var_t - (time_extent_pos[0] - t_extent_max/2),
        0,
        select(
            var_t - (time_extent_pos[0] + t_extent_max/2),
            0 + thin_pattern_f_set[0](var_t, theta, h),
            
            #for(i, 1, time_node_amount+1)
            select(
                var_t - (time_extent_pos[i] - t_extent_max/2),
                thin_pattern_f_set[i-1](var_t, theta, h),
                    select(
                    var_t - (time_extent_pos[i] + t_extent_max/2),
                    thin_pattern_f_set[i-1](var_t, theta, h)     #if(i <= time_node_amount) + thin_pattern_f_set[i](var_t, theta, h) #end,
            #end
                    select(
                        var_t - (time_extent_pos[time_node_amount+1] + t_extent_max/2),
                        thin_pattern_f_set[time_node_amount](var_t, theta, h) + 0,
                        0
                    )
        #for(i, 0, time_node_amount+1)
        ))
        #end
    
    }
    
    
    
    
    
    
    output_f






#end







#macro generate_wood_heart_thin_pattern_f()

#end
